/// <reference types="socket.io" />
/// <reference types="node" />
/// <reference types="socket.io-client" />
import * as http from 'http';
export declare type ReturnFunction = (returnedValue: any, thrownException: any) => any;
export declare type CodeFunction = (returnMethod: ReturnFunction, args: any[]) => void;
export declare type EventFunction = (...args: any[]) => void;
export declare class SioRpcServer {
    io: SocketIO.Server;
    connectedSockets: SocketIO.Socket[];
    private declaredMethods;
    constructor(httpServer: http.Server);
    declare(methodName: string, methodCode: Function): void;
    publish(eventName: string, ...args: any[]): void;
    run(): void;
}
export declare class SioRpcClient {
    socket: SocketIOClient.Socket;
    constructor(url: string);
    call(methodName: string, ...args: any[]): Promise<any>;
    subscribe(eventName: string, eventCode: EventFunction): void;
    subscribeOnce(eventName: string, eventCode: EventFunction): void;
}
